"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const pipe_1 = require("@reactive-js/pipe");
const observable_1 = require("@reactive-js/observable");
const createAsyncEnumerator_1 = require("./createAsyncEnumerator");
const fromArrayScanner = (acc, _) => acc + 1;
class FromArrayAsyncEnumerable {
    constructor(values) {
        this.values = values;
    }
    enumerateAsync(scheduler, replayCount) {
        const values = this.values;
        const operator = (obs) => pipe_1.pipe(obs, observable_1.scan(fromArrayScanner, () => -1), observable_1.map(startIndex => pipe_1.pipe(observable_1.fromArray(values, { startIndex }), observable_1.takeFirst())), observable_1.concatAll(), observable_1.takeFirst(values.length));
        return createAsyncEnumerator_1.createAsyncEnumerator(operator, scheduler, replayCount);
    }
}
exports.fromArray = (values) => new FromArrayAsyncEnumerable(values);
//# sourceMappingURL=fromArray.js.map