import { AsyncEnumerableLike } from "./interfaces";
import { ObservableLike } from "@reactive-js/observable";
import { OperatorLike } from "@reactive-js/pipe";
import { ReducerRequest } from "./reduce";
export declare const reduceAsync: <TReq, TSrc, TAcc>(reducer: (acc: TAcc, next: TSrc) => ObservableLike<ReducerRequest<TReq, TAcc>>, initial: () => ReducerRequest<TReq, TAcc>) => OperatorLike<AsyncEnumerableLike<TReq, TSrc>, ObservableLike<TAcc>>;
