import { ObservableOperatorLike } from "@reactive-js/observable";
import { AsyncEnumerableOperatorLike } from "./interfaces";
interface AsyncEnumeratorRequestOperatorLike<TReqA, TReqB> {
    (notify: (req: TReqA) => void): (ref: TReqB) => void;
}
export declare function lift<TReq, TA, TB>(op: ObservableOperatorLike<TA, TB>): AsyncEnumerableOperatorLike<TReq, TA, TReq, TB>;
export declare function liftReq<TReqA, TReqB, T>(op: AsyncEnumeratorRequestOperatorLike<TReqA, TReqB>): AsyncEnumerableOperatorLike<TReqA, T, TReqB, T>;
export {};
//# sourceMappingURL=lift.d.ts.map